package cz.cvut.fel.pr2.lab06;

import java.util.LinkedList;
import java.util.Queue;

/**
 * @author Ondrej Hrstka
 */
public class NumberGenerator {

    private static final long TOTAL_TASKS = 2000;

    private final Queue<long[]> taskList = new LinkedList<>();
    private long value = 1;
    private long polledTasks = 0;

    public long[] obtain() {
        polledTasks++;
        long[] out = taskList.poll();
        return out;
    }

    public void generateAll() {
        for (long i = 0; i < TOTAL_TASKS; i++) {
            generateBatch();
        }
    }

    private void generateBatch() {
        long[] numbers = new long[100];

        for (int i = 0; i < numbers.length; i++) {
            numbers[i] = value++;
        }

        taskList.add(numbers);
    }

    public long getPolledTasks() {
        return Math.min(polledTasks, TOTAL_TASKS);
    }

    public long getTotalTasks() {
        return TOTAL_TASKS;
    }
}
