package cz.cvut.fel.pr2.lab06;

/**
 * Semaphore is simply synchronized counter. See javadoc for methods {@link Semaphore#acquire()},
 * {@link Semaphore#release()}, {@link Semaphore#releaseAll()}.
 *
 * @see Semaphore#acquire()
 * @see Semaphore#release()
 * @see Semaphore#releaseAll()
 * @author Ondrej Hrstka
 */
public class Semaphore {

    /**
     * Acquires exactly one resources if there is one available (internal counter is greater than zero). If there is
     * not resource available, the method blocks until the resource is available and then acquires one. The acquirement
     * process is represented by decreasing the internal counter by one. Therefore it is impossible to generate counter
     * with the negative value.
     */
    public synchronized void acquire() {
        throw new UnsupportedOperationException("Not yet implemented");
    }

    /**
     * Releases exactly one resource---increases internal counter by one.
     */
    public synchronized void release() {
        throw new UnsupportedOperationException("Not yet implemented");
    }

    /**
     * Releases infinite number of resources. After this method being called the {@link Semaphore#acquire()} method will
     * not block. Never. Ever...
     */
    public synchronized void releaseAll() {
        throw new UnsupportedOperationException("Not yet implemented");
    }

}
