package cz.cvut.fel.pr2.lab06;

/**
 * @author Ondrej Hrstka
 */
public class Worker {

    private final NumberGenerator resource;
    private final NumberCollector collector;

    public Worker(NumberGenerator resource, NumberCollector collector) {
        super();
        this.resource = resource;
        this.collector = collector;
    }

    public synchronized void stopExecution() {
        throw new UnsupportedOperationException("Not yet implemented");
    }

    private void doWork() {
        long[] numbers = resource.obtain();

        if (numbers == null) {
            stopExecution();
        } else {
            long sum = 0;
            for (long number : numbers) {
                sum += number;
            }
            collector.addNumber(sum);
        }
    }
}
