package cz.cvut.fel.pr2.lab06.gui;

import cz.cvut.fel.pr2.lab06.Job;

import javax.swing.*;
import java.awt.*;

/**
 * @author Ondrej Hrstka
 */
public class MainFrame extends JFrame {

    private final Job job = new Job();
    private final JProgressBar jProgressBar = new JProgressBar(JProgressBar.HORIZONTAL, 0, 100);

    public MainFrame() throws HeadlessException {
        super("Thread runner");
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

        setLayout(new GridLayout(2, 1));

        add(createProgressBarPanel());
        add(createButtonPanel());

        pack();
        setVisible(true);
    }

    private JPanel createButtonPanel() {
        JPanel out = new JPanel(new FlowLayout(FlowLayout.CENTER));
        out.add(new JButton(new StartAction(job, jProgressBar)));
        out.add(new JButton(new StopAction(job)));
        return out;
    }

    private JPanel createProgressBarPanel() {
        JPanel out = new JPanel(new GridLayout(1, 1));
        out.add(jProgressBar);
        return out;

    }

    public static void main(String[] args) {
        new MainFrame();
    }

}
