package cz.cvut.fel.pr2.lab06.gui;

import cz.cvut.fel.pr2.lab06.Job;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.util.Observable;
import java.util.Observer;

/**
 * @author Ondrej Hrstka
 */
public class StopAction extends AbstractAction implements Observer {

    private final Job job;

    public StopAction(Job job) {
        super("Stop");
        this.job = job;
        job.addObserver(this);
        update(null, null);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        job.stop();
    }

    @Override
    public void update(Observable o, Object arg) {
        setEnabled(job.isRunning());
    }
}
